%bcond_without base_python

%define python_build_version 3.6

%define __python %{_bindir}/python%{python_build_version}

%if %{with base_python}
%define python_suffix %{expand:%%{lua: str='%{python_build_version}'; print(str:sub(1, 1))}}
%else
%define python_suffix %{expand:%%{lua: str='%{python_build_version}'; print(str:sub(1, 1) .. str:sub(3,-1))}}
%endif

%define pip_version 21.1.2
%define setuptools_version 57.0.0
%define wheel_version 0.36.2

Name: python%{python_suffix}-pip
Version: %{pip_version}
Release: 1
License: MIT
Summary: PyPA recommended tool for installing Python packages
Url: https://pip.pypa.io/

Source0: https://bootstrap.pypa.io/get-pip.py
Source1: https://files.pythonhosted.org/packages/cd/82/04e9aaf603fdbaecb4323b9e723f13c92c245f6ab2902195c53987848c78/pip-21.1.2-py3-none-any.whl
Source2: https://files.pythonhosted.org/packages/4e/78/56aa1b5f4d8ac548755ae767d84f0be54fdd9d404197a3d9e4659d272348/setuptools-57.0.0-py3-none-any.whl
Source3: https://files.pythonhosted.org/packages/65/63/39d04c74222770ed1589c0eaba06c05891801219272420b40311cd60c880/wheel-0.36.2-py2.py3-none-any.whl

BuildArch: noarch

BuildRequires: python%{python_suffix}
BuildRequires: python-rpm-macros

Requires: python%{python_suffix}-setuptools
Requires: python%{python_suffix}-wheel

%description
The PyPA recommended tool for installing Python packages.

%package -n python%{python_suffix}-setuptools
Version: %{setuptools_version}
Release: 1
License: MIT
Summary: Tool to build Python packages
Url: https://setuptools.pypa.io/

%description -n python%{python_suffix}-setuptools
Tool to build Python packages

%package -n python%{python_suffix}-wheel
Version: %{wheel_version}
Release: 1
License: MIT
Summary: A built-package format for Python.
Url: https://github.com/pypa/wheel

%description -n python%{python_suffix}-wheel
A built-package format for Python.




%prep
%setup -T -c

cp %{SOURCE1} %{SOURCE2} %{SOURCE3} .

cat <<EOF > constraint.txt
setuptools==%{setuptools_version}
pip==%{pip_version}
wheel==%{wheel_version}
EOF


%install

%{__python} %{SOURCE0} \
  --root %{buildroot} \
  -I --no-index \
  --find-links . \
  --disable-pip-version-check \
  --no-cache-dir \
  --no-warn-script-location \
  -c constraint.txt \
  setuptools wheel

rm %{buildroot}%{_bindir}/pip
%if ! %{with base_python}
rm %{buildroot}%{_bindir}/pip3
rm %{buildroot}%{_bindir}/wheel
%endif

find %{buildroot}%{python_sitelib} -name \*.exe | xargs rm

# fix INSTALLER to denote it was installed by rpm, not pip
# future versions of pip will disable the version warning
# when INSTALLER does not contain rpm. Unfortunately, as far
# as I can tell, pip always sets this file to "pip" so we must
# always fix it manually
# https://www.python.org/dev/peps/pep-0376/#installer
sed -i 's|pip|rpm|g' %{buildroot}%{python_sitelib}/*.dist-info/INSTALLER

%if %{with base_python}
# Create a default pip.conf file to suppress pip upgrade warnings
# (manually pip-installing an upgrade can cause issues)
mkdir -p %{buildroot}/etc
cat <<EOF > %{buildroot}/etc/pip.conf
[global]
disable-pip-version-check = true
EOF
%endif

%files
%defattr(-, qsys, *none)

%if %{with base_python}
%{_bindir}/pip3
%endif
%{_bindir}/pip%{python_version}

%{python_sitelib}/pip*

%if %{with base_python}
%config(noreplace) /etc/pip.conf
%endif

%files -n python%{python_suffix}-wheel
%defattr(-, qsys, *none)

%if %{with base_python}
%{_bindir}/wheel
%endif

%{python_sitelib}/wheel*

%files -n python%{python_suffix}-setuptools
%defattr(-, qsys, *none)

%{python_sitelib}/distutils-precedence.pth
%{python_sitelib}/_distutils_hack/
%{python_sitelib}/setuptools*
%{python_sitelib}/pkg_resources*

%changelog
* Wed Jun 16 2021 Kevin Adler <kadler@us.ibm.com> - 21.1.2
- Use macros from python-rpm-macros
- Ensure shebang line uses python3.6, not python3
- Update pip to 21.1.2, setuptools to 57.0.0, and wheel to 0.36.2

* Wed Oct 30 2019 - Jesse Gorzinski <jgorzins@us.ibm.com> - 9.0.1
- Ship default pip.conf suppressing version warning

* Sun Aug 05 2018 - Kevin Adler <kadler@us.ibm.com>
- Set INSTALLER to be "rpm" instead of "pip"
- Add --no-index to pip, so it doesn't attempt to connect to the internet

* Tue Jul 17 2018 - Kevin Adler <kadler@us.ibm.com>
- pip should require wheel and setuptools

* Tue Nov 07 2017 - Kevin Adler <kadler@us.ibm.com>
- Initial spec
